# Phaser 3 Physics [en](./README.md)
## **arcade** vs **matter**
Phaser에는 세 가지의 물리 엔진이 있습니다. **arcade**, **matter** 그리고 **impact**입니다. 이중에서, 주로 **arcade** 와 **matter** 가 사용됩니다. (**impact**에 대해서는 공식 문서에도 내용이 많이 없습니다. <strong>[Phaser API docs](https://photonstorm.github.io/phaser3-docs/Phaser.Physics.Impact.html)</strong>). 그렇다면, **arcade**와 **matter**간에 무슨 차이가 있는 것인지 궁금하실 겁니다.

---
## 성능 비교: **arcade** vs **matter**
만약 이에 대해서 찾아보신 적이 있다면 **arcade**가 간단한 게임에 더 적합하다는 내용을 찾아보실 수 있을 것입니다. 물론, 이는 맞는 얘기입니다. **matter**는 보다 복잡하고 세밀한 물리 세계를 구현할 수 있고, 이는 보다 많은 메모리의 사용을 요구합니다. 그렇기에 똑같이 간단한 게임을 만들었더라도 **matter** 물리 엔진은 기본적으로 **arcade** 물리 엔진 보다 많은 메모리의 사용을 요구합니다. 이에 대해서 많은 토론과 내용이 있으며, 이 토론이 도움이 될 수 있습니다: https://phaser.discourse.group/t/arcade-vs-matterjs-performance/7218.

---
## 물리 엔진 비교: **arcade** vs **matter**
위의 내용만 본다면 **matter**가 **arcade**보다 많은 메모리를 소비하는데 굳이 쓸 필요가 있을까 하는 의문이 생길 수 있습니다. 그 대답 중 하나는 **matter**가 **arcade** 보다 복잡한 오브젝트 body나 그들의 체인을 통한 연결 등 훨씬 복잡하고 다양한 물리 세계를 구현할 수 있다는 것입니다. 그러므로, 보다 복잡한 물리 세계를 구현하고 싶으시다면  **matter**를 사용하거나 **arcade**와 혼합하여 사용하실 수 있습니다.

---
## 3D 게임을 만들 방법은 없을까요?
**arccade**와  **matter** 물리 엔진은 기본적으로 2D 게임 개발에 초점이 맞춰져있습니다. Phaser 3 공식 API 문서를 확인해본 다면, 두 물리 엔진에 속한 오브젝트들이  ```setVelocity(x [, y])``` 함수를 갖고 있음을 볼 수 있습니다. 보시다시피, x축과 y축에 대한 값만 이용하고 있습니다. 즉, 3D 환경에서의 개발을 고려하지 않았다고 볼 수도 있습니다. 물론 방법이 아예 없는 것은 아닙니다. 3D 카메라 플러그인을 활용할 수도 있으나, 원하는 것을 만들기에는 부적합할 확률이 높습니다. 하지만 [**enable3D**](https://github.com/enable3d/enable3d)라는 Phaser 3 3D 게임 개발을 위한 활용성 좋은 extension이 있습니다.



<br><br>

---
[메인으로](../README_kr.md)

<br><br><br><br>
<img src="../by.png" alt="CC_BY" width="150"/>